SystemOrganization addCategory: #'OB-SUnitIntegration'!

!OBCodeBrowser methodsFor: '*ob-sunitIntegration' stamp: 'dc 7/22/2007 20:47'!
cmdSUnitIntegration
	^ {OBCmdTestCategory. OBCmdTestClass. OBCmdTestMethod}! !

OBCommand subclass: #OBCmdSUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-SUnitIntegration'!

!OBCmdSUnit methodsFor: 'accessing' stamp: 'dc 7/22/2007 20:45'!
keystroke
	^ $t! !

!OBCmdSUnit methodsFor: 'accessing' stamp: 'dc 7/24/2007 12:38'!
label
	^ 'runs the test(s)'! !

OBCmdSUnit subclass: #OBCmdTestCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-SUnitIntegration'!

!OBCmdTestCategory methodsFor: 'execution' stamp: 'dc 7/24/2007 20:38'!
execute
	| res classes defectSuites |
	classes := target classes collect: [:n| n theClass].
	res := classes collect: [:cls| cls buildSuite run].
	(res allSatisfy: [:r | r hasPassed]) 
		ifTrue: [self successNotification]
		ifFalse: [defectSuites := res select: [:r | r hasPassed not].
				 (defectSuites size > 4) ifTrue: 
					[defectSuites := defectSuites copyFrom: 1 to: 4].
				 defectSuites := defectSuites 
									inject: '' 
									into: [:sum :el| sum, ' ',  (classes at: (res indexOf: el)) name].
				self inform: 'Failed test suite => ', defectSuites]! !

!OBCmdTestCategory methodsFor: 'testing' stamp: 'ab 6/16/2007 10:03'!
isActive
	^ (target isKindOf: OBClassCategoryNode)
		and: [requestor isSelected: target]
		and: [target classes anySatisfy: [:cls | cls theClass inheritsFrom: TestCase]]! !

OBCmdSUnit subclass: #OBCmdTestClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-SUnitIntegration'!

!OBCmdTestClass methodsFor: 'execution' stamp: 'dc 7/24/2007 20:38'!
execute
	| res defectSelectors |
	res := target theClass buildSuiteFromSelectors run.
	res hasPassed 
		ifTrue: [self successNotification]
		ifFalse: 
			[defectSelectors := res defects collect: [:ts | ts selector].
			defectSelectors size > 4 
				ifTrue: [defectSelectors := defectSelectors copyFrom: 1 to: 4].
			defectSelectors := defectSelectors inject: ''
						into: [:sum :el | sum , ' ' , el asString].
			self inform: res printString , ' => ' , defectSelectors]! !

!OBCmdTestClass methodsFor: 'testing' stamp: 'dc 4/24/2007 13:38'!
isActive
	^ (target isKindOf: OBClassNode)
		and: [requestor isSelected: target]
		and: [target theClass inheritsFrom: TestCase]! !

!OBCmdTestClass methodsFor: 'execution' stamp: 'dc 7/24/2007 20:38'!
successNotification
	OBInformRequest message: 'All tests pass!!'! !

OBCmdSUnit subclass: #OBCmdTestMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-SUnitIntegration'!

!OBCmdTestMethod methodsFor: 'execution' stamp: 'dc 7/24/2007 20:38'!
execute
	target theClass debug: target selector.
	self successNotification
! !

!OBCmdTestMethod methodsFor: 'testing' stamp: 'dc 4/24/2007 13:31'!
isActive
	^ (target isKindOf: OBMethodNode)
		and: [requestor isSelected: target]
		and: [target theClass inheritsFrom: TestCase]
		and: [target selector beginsWith: 'test']! !
